function Component()
{

}

Component.prototype.createOperations = function()
{
    component.createOperations();

    // Configure here the registry operations required for windows

    if (installer.value("os") == "win")
    {
        var iconsDir = installer.value("TargetDir") + "\\Icons";
		iconsDir = iconsDir.split("/");
		iconsDir = iconsDir.join("\\");
		var execApp = installer.value("TargetDir") + "\\iLovePDF.exe";
        execApp = execApp.split("/");
        execApp = execApp.join("\\");
		
		console.log("TEST4: " + execApp);

        // PDF files context menu

        /* Add .pdf extension treatment if it does not exist */
        component.addElevatedOperation("Execute",
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf", 
                                       "/f");

        /* Create shell context menu, if it does not exist */
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell", 
                                       "/f");

        /* Create iLovePDF menu and delete it when uninstalling = UNDOEXECUTE */
        component.addElevatedOperation("Execute",
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF", 
                                       "/f",
                                       "UNDOEXECUTE",
									   "{0,1}",
                                       "cmd", 
                                       "/C", 
                                       "reg", "DELETE", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF", 
                                       "/f");

        /* Create iLovePDF root values */
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF", 
                                       "/v", "MUIVerb", 
                                       "/t", "REG_SZ", 
                                       "/d", "iLovePDF", 
                                       "/f");

        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF", 
                                       "/v", "subCommands", 
                                       "/t", "REG_SZ", 
                                       "/d",  "", 
                                       "/f");
        

        var iLovePdfIcon = iconsDir + "\\iLovePdfApp.ico";
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF", 
                                       "/v", "Icon", 
                                       "/t", "REG_SZ", 
                                       "/d", iLovePdfIcon, 
                                       "/f");

        /* Create iLovePDF first level menu */
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell",
                                       "/f");

/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	OPTION 1 --  COMPRESS																     */
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option1_Compress", 
                                       "/v", "MUIVerb", 
                                       "/t", "REG_SZ", 
                                       "/d", "Compress PDF", 
                                       "/f");  

        iLovePdfIcon = iconsDir + "\\compress.ico";
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option1_Compress", 
                                       "/v", "Icon", 
                                       "/t", "REG_SZ", 
                                       "/d", iLovePdfIcon, 
                                       "/f"); 

        var fullCommand = execApp + " -compress " + "\"%1\""
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option1_Compress\\command", 
                                       "/d", fullCommand,
                                       "/f");                                                                                
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	OPTION 2 --  EXTRACT PAGES																     */
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option2_ExtractPages", 
                                       "/v", "MUIVerb", 
                                       "/t", "REG_SZ", 
                                       "/d", "Extract all pages", 
                                       "/f"); 

        iLovePdfIcon = iconsDir + "\\extract.ico";
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option2_ExtractPages", 
                                       "/v", "Icon", 
                                       "/t", "REG_SZ", 
                                       "/d", iLovePdfIcon, 
                                       "/f");

        var fullCommand = execApp + " -extract_all_pages " + "\"%1\""
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option2_ExtractPages\\command", 
                                       "/d", fullCommand,
                                       "/f");                                       
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	OPTION 3 --  EXTRACT IMAGES																     */
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option3_ExtractImages", 
                                       "/v", "MUIVerb", 
                                       "/t", "REG_SZ", 
                                       "/d", "Extract images", 
                                       "/f"); 

        var exractIcon = iconsDir + "\\extract.ico";
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option3_ExtractImages", 
                                       "/v", "Icon", 
                                       "/t", "REG_SZ", 
                                       "/d", exractIcon, 
                                       "/f");                                        

        var fullCommand = execApp + " -extract_images " + "\"%1\""
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option3_ExtractImages\\command", 
                                       "/d", fullCommand,
                                       "/f");
									   
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	OPTION 4 --  REPAIR																     */
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

		component.addElevatedOperation("Execute", 
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option4_Repair", 
                                       "/v", "MUIVerb", 
                                       "/t", "REG_SZ", 
                                       "/d", "Repair PDF", 
                                       "/f"); 

        iLovePdfIcon = iconsDir + "\\repair_PDF.ico";
        component.addElevatedOperation("Execute", 
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option4_Repair", 
                                       "/v", "Icon", 
                                       "/t", "REG_SZ", 
                                       "/d", iLovePdfIcon, 
                                       "/f");

        var fullCommand = execApp + " -repair " + "\"%1\""
        component.addElevatedOperation("Execute", 
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option4_Repair\\command", 
                                       "/d", fullCommand,
                                       "/f");
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	OPTION 4 --  UNLOCK																     */
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/

		component.addElevatedOperation("Execute", 
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option4_Unlock", 
                                       "/v", "MUIVerb", 
                                       "/t", "REG_SZ", 
                                       "/d", "Unlock PDF", 
                                       "/f"); 

        iLovePdfIcon = iconsDir + "\\unlock_PDF.ico";
        component.addElevatedOperation("Execute", 
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option4_Unlock", 
                                       "/v", "Icon", 
                                       "/t", "REG_SZ", 
                                       "/d", iLovePdfIcon, 
                                       "/f");

        var fullCommand = execApp + " -unlock " + "\"%1\""
        component.addElevatedOperation("Execute", 
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option4_Unlock\\command", 
                                       "/d", fullCommand,
                                       "/f");
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	OPTION 5 --  CONVERT PDF																     */
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf", 
                                       "/v", "MUIVerb", 
                                       "/t", "REG_SZ", 
                                       "/d", "Convert", 
                                       "/f");

        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf", 
                                       "/v", "subCommands", 
                                       "/t", "REG_SZ", 
                                       "/d", "", 
                                       "/f"); 

        var convertIcon = iconsDir + "\\iLovePdfApp.ico";
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf", 
                                       "/v", "Icon", 
                                       "/t", "REG_SZ", 
                                       "/d", convertIcon, 
                                       "/f"); 

        /* Create iLovePDF second level menu  for Convert options */
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf\\shell", 
                                       "/f");  
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	OPTION 5 --  CONVERT PDF TO JPG																     */
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf\\shell\\Option1_toJpg", 
                                       "/v", "MUIVerb", 
                                       "/t", "REG_SZ", 
                                       "/d", "To JPG", 
                                       "/f");

        convertIcon = iconsDir + "\\pdf_to_jpg.ico";
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf\\shell\\Option1_toJpg", 
                                       "/v", "Icon", 
                                       "/t", "REG_SZ", 
                                       "/d", convertIcon, 
                                       "/f");

        var fullCommand = execApp + " -convert_to_jpg " + "\"%1\""
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf\\shell\\Option1_toJpg\\command", 
                                       "/d", fullCommand,
                                       "/f");                                                                                                                    
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	OPTION 5 --  CONVERT PDF TO WORD																*/
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf\\shell\\Option2_toWord", 
                                       "/v", "MUIVerb", 
                                       "/t", "REG_SZ", 
                                       "/d", "To Word", 
                                       "/f");
        
        convertIcon = iconsDir + "\\pdf_to_word.ico";
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf\\shell\\Option2_toWord", 
                                       "/v", "Icon", 
                                       "/t", "REG_SZ", 
                                       "/d", convertIcon, 
                                       "/f");

        var fullCommand = execApp + " -convert_to_word " + "\"%1\""
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf\\shell\\Option2_toWord\\command", 
                                       "/d", fullCommand,
                                       "/f");
								   
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	OPTION 5 --  CONVERT PDF TO EXCEL																 */
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf\\shell\\Option3_toExcel", 
                                       "/v", "MUIVerb", 
                                       "/t", "REG_SZ", 
                                       "/d", "To Excel", 
                                       "/f");

        convertIcon = iconsDir + "\\pdf_to_excel.ico";
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf\\shell\\Option3_toExcel", 
                                       "/v", "Icon", 
                                       "/t", "REG_SZ", 
                                       "/d", convertIcon, 
                                       "/f");                                                                             

        var fullCommand = execApp + " -convert_to_excel " + "\"%1\""
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf\\shell\\Option3_toExcel\\command", 
                                       "/d", fullCommand,
                                       "/f");
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	OPTION 5 --CONVERT PDF TO PowerPoint															 */
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf\\shell\\Option4_toPowerPoint", 
                                       "/v", "MUIVerb", 
                                       "/t", "REG_SZ", 
                                       "/d", "To PowerPoint", 
                                       "/f");
                                    
        convertIcon = iconsDir + "\\pdf_to_powerpoint.ico";
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf\\shell\\Option4_toPowerPoint", 
                                       "/v", "Icon", 
                                       "/t", "REG_SZ", 
                                       "/d", convertIcon, 
                                       "/f");                                    
        
        var fullCommand = execApp + " -convert_to_powerpoint " + "\"%1\""
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf\\shell\\Option4_toPowerPoint\\command", 
                                       "/d", fullCommand,
                                       "/f");
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	OPTION 6 --  CONVERT PDF TO PDF/A																*/
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf\\shell\\Option6_toPdfA", 
                                       "/v", "MUIVerb", 
                                       "/t", "REG_SZ", 
                                       "/d", "To PDF/A", 
                                       "/f"); 

        convertIcon = iconsDir + "\\pdf_to_pdfa.ico";
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf\\shell\\Option6_toPdfA", 
                                       "/v", "Icon", 
                                       "/t", "REG_SZ", 
                                       "/d", convertIcon, 
                                       "/f");                                                                                                                                                                                     
        var fullCommand = execApp + " -convert_to_pdfa " + "\"%1\""
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option5_ConvertPDf\\shell\\Option6_toPdfA\\command", 
                                       "/d", fullCommand,
                                       "/f");
									   
								   
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	OPTION 6 -- OpenApp																			     */
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/		
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option6_OpenApp", 
                                       "/v", "MUIVerb", 
                                       "/t", "REG_SZ", 
                                       "/d", "Open in a new tab...", 
                                       "/f"); 

        iLovePdfIcon = iconsDir + "\\iLovePdfApp.ico";
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option6_OpenApp", 
                                       "/v", "Icon", 
                                       "/t", "REG_SZ", 
                                       "/d", iLovePdfIcon, 
                                       "/f");                                                                                                                         

        var fullCommand = execApp + " -new_tab \"%1\" ";
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option6_OpenApp\\command", 
                                       "/d", fullCommand,
                                       "/f");                                       
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	OPTION 7 -- OpenNewWindow																		*/
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/									   
		component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option7_OpenNewWindow", 
                                       "/v", "MUIVerb", 
                                       "/t", "REG_SZ", 
                                       "/d", "Open in a new window...", 
                                       "/f"); 

        iLovePdfIcon = iconsDir + "\\iLovePdfApp.ico";
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option7_OpenNewWindow", 
                                       "/v", "Icon", 
                                       "/t", "REG_SZ", 
                                       "/d", iLovePdfIcon, 
                                       "/f");                                                                                                                         

        var fullCommand = execApp + " \"%1\"";
        component.addElevatedOperation("Execute", 
									   "{0,1}",
                                       "cmd", "/C", 
                                       "reg", "ADD", 
                                       "HKEY_CLASSES_ROOT\\SystemFileAssociations\\.pdf\\shell\\iLovePDF\\shell\\Option7_OpenNewWindow\\command", 
                                       "/d", fullCommand,
                                       "/f");


/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	OFFICE TO PDF																					*/
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
// Office files context menu

		var officeExtensions = [".docx",".doc",".odt", ".xls",".xlsx",".ods",".ppt",".pptx",".odp"];
		for(var i = 0; i < officeExtensions.length; i++){
			/* Add .pdf extension treatment if it does not exist */
			component.addElevatedOperation("Execute",
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i], 
										   "/f");

			/* Create shell context menu, if it does not exist */
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell", 
										   "/f");

			/* Create iLovePDF menu and delete it when uninstalling = UNDOEXECUTE */
			component.addElevatedOperation("Execute",
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF", 
										   "/f",
										   "UNDOEXECUTE",
										   "{0,1}",
										   "cmd", 
										   "/C", 
										   "reg", "DELETE", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF", 
										   "/f");

			/* Create iLovePDF root values */
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF", 
										   "/v", "MUIVerb", 
										   "/t", "REG_SZ", 
										   "/d", "iLovePDF", 
										   "/f");

			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF", 
										   "/v", "subCommands", 
										   "/t", "REG_SZ", 
										   "/d",  "", 
										   "/f");
			

			var iLovePdfIcon = iconsDir + "\\iLovePdfApp.ico";
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF", 
										   "/v", "Icon", 
										   "/t", "REG_SZ", 
										   "/d", iLovePdfIcon, 
										   "/f");

			/* Create iLovePDF first level menu */
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF\\shell",
										   "/f");


		}


/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	OPTION 5 --  CONVERT WORD TO PDF																*/
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
        var officeExtensions = [".docx", ".doc", ".odt"];
		for(var i = 0; i < officeExtensions.length; i++){
		
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF\\shell\\Option1_toPdf", 
										   "/v", "MUIVerb", 
										   "/t", "REG_SZ", 
										   "/d", "Convert to PDF (Online Tool)", 
										   "/f");  

			iLovePdfIcon = iconsDir + "\\word_to_pdf.ico";
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF\\shell\\Option1_toPdf", 
										   "/v", "Icon", 
										   "/t", "REG_SZ", 
										   "/d", iLovePdfIcon, 
										   "/f");

			var fullCommand = execApp + " -convert_word_to_pdf " + "\"%1\""
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF\\shell\\Option1_toPdf\\command", 
										   "/d", fullCommand,
										   "/f");
		}

/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	OPTION 4 --  CONVERT EXCEL TO PDF																*/
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
        var officeExtensions = [".xls", ".xlsx", ".ods"];
		for(var i = 0; i < officeExtensions.length; i++){
		
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF\\shell\\Option2_toPdf", 
										   "/v", "MUIVerb", 
										   "/t", "REG_SZ", 
										   "/d", "Convert to PDF (Online Tool)", 
										   "/f");  

			iLovePdfIcon = iconsDir + "\\excel_to_pdf.ico";
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF\\shell\\Option2_toPdf", 
										   "/v", "Icon", 
										   "/t", "REG_SZ", 
										   "/d", iLovePdfIcon, 
										   "/f");

			var fullCommand = execApp + " -convert_excel_to_pdf " + "\"%1\""
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF\\shell\\Option2_toPdf\\command", 
										   "/d", fullCommand,
										   "/f");
		}	

/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	OPTION 4 --  CONVERT POWERPOINT TO PDF																*/
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
        var officeExtensions = [".ppt", ".pptx", ".odp"];
		for(var i = 0; i < officeExtensions.length; i++){
		
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF\\shell\\Option3_toPdf", 
										   "/v", "MUIVerb", 
										   "/t", "REG_SZ", 
										   "/d", "Convert to PDF (Online Tool)", 
										   "/f");  

			iLovePdfIcon = iconsDir + "\\powerpoint_to_pdf.ico";
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF\\shell\\Option3_toPdf", 
										   "/v", "Icon", 
										   "/t", "REG_SZ", 
										   "/d", iLovePdfIcon, 
										   "/f");

			var fullCommand = execApp + " -convert_powerpoint_to_pdf " + "\"%1\""
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF\\shell\\Option3_toPdf\\command", 
										   "/d", fullCommand,
										   "/f");
		}		

                                       
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	IMAGES																		*/
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/	
        
		var officeExtensions = [".jpg", ".jpeg", ".png", ".tiff", ".tif"];
		for(var i = 0; i < officeExtensions.length; i++){
			// JPG files context menu
			/* Add .jps extension treatment if it does not exist */
			component.addElevatedOperation("Execute",
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i], 
										   "/f");

			/* Create shell context menu, if it does not exist */
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell", 
										   "/f");

			/* Create iLovePDF menu and delete it when uninstalling = UNDOEXECUTE */
			component.addElevatedOperation("Execute",
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF", 
										   "/f",
										   "UNDOEXECUTE",
										   "{0,1}",
										   "cmd", 
										   "/C", 
										   "reg", "DELETE", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF", 
										   "/f");

			/* Create iLovePDF root values */
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF", 
										   "/v", "MUIVerb", 
										   "/t", "REG_SZ", 
										   "/d", "iLovePDF", 
										   "/f");

			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF", 
										   "/v", "subCommands", 
										   "/t", "REG_SZ", 
										   "/d",  "", 
										   "/f");
			

			var iLovePdfIcon = iconsDir + "\\iLovePdfApp.ico";
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF", 
										   "/v", "Icon", 
										   "/t", "REG_SZ", 
										   "/d", iLovePdfIcon, 
										   "/f");

			/* Create iLovePDF first level menu */
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF\\shell",
										   "/f");
		}

/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/
/*																	 IMAGE TO PDF																						*/
/*-------------------------------------------------------------------------------------------------------------------------------------------------------------------*/	

		var officeExtensions = [".jpg", ".jpeg", ".png", ".tiff", ".tif"];
		for(var i = 0; i < officeExtensions.length; i++){
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF\\shell\\Option1_toPdf", 
										   "/v", "MUIVerb", 
										   "/t", "REG_SZ", 
										   "/d", "Convert to PDF", 
										   "/f");  

			iLovePdfIcon = iconsDir + "\\image_to_pdf.ico";
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF\\shell\\Option1_toPdf", 
										   "/v", "Icon", 
										   "/t", "REG_SZ", 
										   "/d", iLovePdfIcon, 
										   "/f");

			var fullCommand = execApp + " -convert_to_pdf " + "\"%1\""
			component.addElevatedOperation("Execute", 
										   "{0,1}",
										   "cmd", "/C", 
										   "reg", "ADD", 
										   "HKEY_CLASSES_ROOT\\SystemFileAssociations\\" + officeExtensions[i] + "\\shell\\iLovePDF\\shell\\Option1_toPdf\\command", 
										   "/d", fullCommand,
										   "/f");
		}
/*------------------------------------------------------------------------------------------------------------------------------------------------*/		
		//Register On Windows Start Menu
		component.addOperation("CreateShortcut",
								"@TargetDir@/iLovePDF.exe",
								"@StartMenuDir@/iLovePDF.lnk",
								"workingDirectory=@TargetDir@",
								"iconPath="+iconsDir+"/iLovePdfApp.ico",
								"iconId=0",
								"description=Open iLovePDF");
		
		//Create Windows Desktop Shortcut
		component.addOperation("CreateShortcut",
								"@TargetDir@/iLovePDF.exe",
								"@DesktopDir@/iLovePDF.lnk",
								"workingDirectory=@TargetDir@",
								"iconPath="+iconsDir+"/iLovePdfApp.ico",
								"iconId=0",
								"description=Open iLovePDF");
								
		component.addOperation("RegisterFileType",
								"pdf",
								execApp + " -new_tab \"%1\"",
								"PDF file type",
								"application/pdf",
								execApp + ",1",
								"ProgId=iLovePDF.pdf");
								
    }else if(installer.value("os") == "mac"){
		var solidPath = installer.value("TargetDir") + "/iLovePDF.app/Contents/Frameworks/SolidFrameworkNative.framework/";

		component.addElevatedOperation("Execute",
									   "{0,1}",
                                       "ln",
									   "-s",
									   solidPath + "Versions/A",
									   solidPath + "Versions/Current",
									   "UNDOEXECUTE",
									   "{0,1}",
									   "unlink",
									   solidPath + "Versions/Current");

		component.addElevatedOperation("Execute",
										"{0,1}",
										"ln",
										"-s",
										solidPath + "Versions/Current/Libraries",
										solidPath + "Libraries",
										"UNDOEXECUTE",
										"{0,1}",
										"unlink",
										solidPath + "Libraries");

		component.addElevatedOperation("Execute",
										"{0,1}",
										"ln",
										"-s",
										solidPath + "Versions/Current/Resources",
										solidPath + "Resources",
										"UNDOEXECUTE",
										"{0,1}",
										"unlink",
										solidPath + "Resources");


		component.addElevatedOperation("Execute",
										"{0,1}",
										"ln",
										"-s",
										solidPath + "Versions/Current/SolidFrameworkNative",
										solidPath + "SolidFrameworkNative",
										"UNDOEXECUTE",
										"{0,1}",
										"unlink",
										solidPath + "SolidFrameworkNative");
	}
}
